' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2010/10/18 
'
' FPM2 Search Sample Program
' -----------------------------------------------------------------
Public Class Form_FPM2_SEARCH_SAMPLE

    '摜i[̈
    Private m_image As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()
    'rfI̓NX
    Private m_video As FVIL.Video.CFviVideo
    '_p}b`ONX
    Private m_matching As FVIL.FPM2.CFviFPM2Matching = New FVIL.FPM2.CFviFPM2Matching()
    'FPM2p[^NX
    Private m_param As FVIL.FPM2.CFviFPM2Param = New FVIL.FPM2.CFviFPM2Param()
    Private m_paramA As FVIL.FPM2.CFviFPM2ParamAreaScore = New FVIL.FPM2.CFviFPM2ParamAreaScore()
    Private m_paramE As FVIL.FPM2.CFviFPM2ParamEssential = New FVIL.FPM2.CFviFPM2ParamEssential()
    'FPM2ev[gʒoNX
    Private m_template As FVIL.FPM2.CFviFPM2Template
    'FPM2}b`O[h
    Private m_matchmode As FVIL.FPM2.MatchMode
    'QGbWop[^NX(փGbW@)
    Private m_edgeparam As FVIL.Edge.CFviEdge2DCorrelationParam = New FVIL.Edge.CFviEdge2DCorrelationParam()
    'QGbWop[^NX(Sobel@)
    Private m_sobelparam As FVIL.Edge.CFviEdge2DSobelParam = New FVIL.Edge.CFviEdge2DSobelParam()
    'p^\NX
    Private m_pattern As FVIL.Data.CFviPattern = New FVIL.Data.CFviPattern()
    '\pI[o[CNX錾
    Private m_overlay As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
    'GbW\pI[o[CNX錾
    Private m_overlayEdge As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
    'ԌvNX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()

    'init@CݒtH[
    Public formBroseIni As Form_BROWSEINI = New Form_BROWSEINI()

    'init@CitpXj
    Public m_strIniFilePath As String
    'rfIfoCX̃I[v
    Private m_flgVideoOpened As Boolean
    'ԑp
    Dim msec As Double = 0

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False
        'FPM _p }b`O[h̏
        m_matchmode = FVIL.FPM2.MatchMode.HighSpeed

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'FPM2R{{bNX
        comboBoxCompressionLevel.Items.Clear()
        comboBoxCompressionLevel.Items.Add("0")
        comboBoxCompressionLevel.Items.Add("1")
        comboBoxCompressionLevel.Items.Add("2")
        comboBoxCompressionLevel.Items.Add("3")
        comboBoxCompressionLevel.Items.Add("4")
        comboBoxCompressionLevel.Items.Add("5")
        comboBoxCompressionLevel.SelectedIndex = 3

        'FPM2tB^IR{{bNX
        ComboBoxSelectFilter.Items.Clear()
        ComboBoxSelectFilter.Items.Add("փGbW")
        ComboBoxSelectFilter.Items.Add("\[x")
        ComboBoxSelectFilter.SelectedIndex = 0

        'FPM2GbWɐIR{{bNX
        comboBoxPolarity.Items.Clear()
        comboBoxPolarity.Items.Add("ɐȂ")
        comboBoxPolarity.Items.Add("ɐ]")
        comboBoxPolarity.Items.Add("ɐ")
        comboBoxPolarity.SelectedIndex = 0
    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> System.Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        CFviImageView1.Image = Me.m_image

        'I[o[C̒ǉ
        CFviImageView1.Display.Overlays.Add(m_overlay)
        CFviImageView1.Display.Overlays.Add(m_overlayEdge)
    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()

        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'ݒt@C̃[hƃfoCXI[v
                m_video = FVIL.Video.Function.CreateInstance(m_strIniFilePath)
                '摜TCY
                m_video.ChangeImageSize(m_image)
                m_flgVideoOpened = True

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxTrigger.SelectedIndex = m_video.Trigger
                'JIԂ̎擾
                If (m_video.DeviceType <> FVIL.Video.DeviceType.RICE001) Then
                    NumericUpDownExposure.Value = m_video.ExposureTime
                Else
                    TabControlParam.TabPages.Remove(TabPageBoard)
                End If
                ButtonGrabOne.Enabled = True
            Catch ex As FVIL.CFviException
                'G[
                MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                'G[
                MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        ElseIf (Form_BROWSEINI.UseFileFlg = True) Then
            ButtonGrabOne.Enabled = False
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Try
            m_overlay.Figures.Clear()
            formBroseIni.UseFileFlg = False

            'foCX^Cv
            Select Case m_video.DeviceType
                Case FVIL.Video.DeviceType.FVC05, FVIL.Video.DeviceType.FVC06, FVIL.Video.DeviceType.FVC07, FVIL.Video.DeviceType.FV1300, FVIL.Video.DeviceType.GP440, FVIL.Video.DeviceType.RICE001
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    m_video.GrabImageSync(m_image)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3312
                    Dim video As FVIL.Video.CFviVideoFHC3312 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3312)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3312 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
                Case FVIL.Video.DeviceType.FHC3313
                    Dim video As FVIL.Video.CFviVideoFHC3313 = DirectCast(m_video, FVIL.Video.CFviVideoFHC3313)
                    Dim contgrab As FVIL.Video.CFviContinuousGrabFHC3313 = video.ContinuousGrab
                    'bN
                    contgrab.MemoryLock(m_image)
                    'ԑJn
                    m_timer.Start()
                    'J荞
                    contgrab.GrabSync(1)
                    'ԑI
                    msec = m_timer.Stop()
            End Select
            TextBoxTime.Text = msec.ToString("0.000")   '莞ԕ\
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged, ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub ExposureValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged, NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' LoadFile {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ͉摜t@C̃[hB
    ''' </remarks>
    Private Sub buttonLoadImageFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonLoadImageFile.Click
        Form_BROWSEINI.UseFileFlg = True
        '͉摜t@C̃[h
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Filter = "Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        OpenFileDialog1.Filter += "|Png t@C (*.png)|*.png"
        OpenFileDialog1.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        OpenFileDialog1.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        OpenFileDialog1.DefaultExt = "*.bmp"
        If ((OpenFileDialog1.FileNames.Length <= 0) Or (OpenFileDialog1.ShowDialog(Me) = System.Windows.Forms.DialogResult.Cancel)) Then
            Return
        End If

        Try
            FVIL.File.Function.LoadImageFile(OpenFileDialog1.FileName, m_image, FVIL.PixelMode.Unpacking)
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click

        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.SaveImageFile(ofdlg.FileName, CFviImageView1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED,
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub

    ''' <summary>
    ''' T[`s{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' T[`Eʕ\B
    ''' </remarks>
    Private Sub buttonMatching_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonMatching.Click
        '\
        m_overlay.Figures.Clear()
        listViewResult.Items.Clear()
        'ĕ`
        CFviImageView1.Refresh()

        'p[^ݒ
        If (fnFPMPraramSet()) Then
            'T[`s
            If (fnFPMExec()) Then
                'ʕ\
                fnResultDisplay()
            End If
        End If
    End Sub

    ''' <summary>
    ''' p[^ݒ
    ''' </summary>
    ''' <remarks>
    ''' p[^ݒ֐
    ''' </remarks>
    Private Function fnFPMPraramSet() As Boolean
        Dim temp1, temp2 As Integer
        Dim Result As Boolean = False

        '
        m_param.Count = numericUpDownCount.Value
        temp1 = numericUpDownAngleMin.Value
        temp2 = numericUpDownAngleMax.Value
        If (temp1 <= temp2) Then
            ']p()
            m_param.AngleMin = New FVIL.Data.CFviAngle(numericUpDownAngleMin.Value)
            ']p()
            m_param.AngleMax = New FVIL.Data.CFviAngle(numericUpDownAngleMax.Value)
        Else
            MessageBox.Show("]p̏㉺]Ă܂", "Parameter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (Result)
        End If
        temp1 = numericUpDownScaleMin.Value
        temp2 = numericUpDownScaleMax.Value
        If (temp1 <= temp2) Then
            'XP[()
            m_param.ScaleMin = numericUpDownScaleMin.Value
            'XP[()
            m_param.ScaleMax = numericUpDownScaleMax.Value
        Else
            MessageBox.Show("XP[̏㉺]Ă܂", "Parameter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (Result)
        End If
        'kx
        m_param.CompressionLevel = comboBoxCompressionLevel.SelectedIndex
        '덷͈
        m_param.ErrorRange = numericUpDownErrorRange.Value
        'XRA臒l(ሳkp)
        m_param.ScoreThresholdL = numericUpDownScoreThresholdL.Value
        'XRA臒l(kp)
        m_param.ScoreThresholdH = numericUpDownScoreThresholdH.Value
        'x|[Y̎sw
        m_param.RefineEnable = checkBoxRefineFlag.Checked
        Select Case (comboBoxPolarity.SelectedIndex)
            Case 0
                m_param.Polarity = FVIL.FPM2.Polarity.Same         'GbWɐFɐȂ
            Case 1
                m_param.Polarity = FVIL.FPM2.Polarity.Reverse      'GbWɐFɐ]
            Case 2
                m_param.Polarity = FVIL.FPM2.Polarity.Either       'GbWɐFɐ
        End Select
        'FPM2 ̈XRAZopp[^ݒ
        '덷͈(Xil)
        m_paramA.ErrorRangeTx = Double.Parse(textBoxAreaErrorRangeTx.Text.ToString())
        '덷͈(Yil)
        m_paramA.ErrorRangeTy = Double.Parse(textBoxAreaErrorRangeTy.Text.ToString())
        '덷͈(]p)
        m_paramA.ErrorRangeTq = Double.Parse(textBoxAreaErrorRangeTq.Text.ToString())
        '덷͈(XP[)
        m_paramA.ErrorRangeTs = Double.Parse(textBoxAreaErrorRangeTs.Text.ToString())
        '덷͈
        m_paramA.ErrorRange = numericUpDownAreaErrorRange.Value
        'mCYf[^d݌W
        m_paramA.NoiseWeight = Double.Parse(textBoxAreaNoiseWeight.Text.ToString())
        'XRA臒l
        m_paramA.ScoreThreshold = numericUpDownAreaScoreThreshold.Value
        'FPM2 s̈XRAZopp[^ݒ
        '덷͈
        m_paramE.ErrorRange = numericUpDownEssenErrorRange.Value
        'XRA臒l
        m_paramE.ScoreThreshold = numericUpDownEssenScoreThreshold.Value

        'p^̃GbW쐬
        Result = fnMakePatternEdge()

        m_matching.Param = m_param              '{p[^
        m_matching.ParamAreaScore = m_paramA    '̈XRAZo
        m_matching.ParamEssential = m_paramE    's̈XRAvZ
        m_matching.EnableAreaScore = checkBoxAreaScoreFlag.Checked  '̈XRAZo̎sw
        m_matching.EnableEssential = checkBoxEssentialFlg.Checked   's̈XRAZo̎sw

        Return (Result)
    End Function

    ''' <summary>
    ''' T[`s
    ''' </summary>
    ''' <remarks>
    ''' }b`Os֐
    ''' </remarks>
    Private Function fnFPMExec() As Boolean
        Dim Result As Boolean = False

        Try
            Dim feature As FVIL.FPM2.CFviFPM2Feature
            If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                'FPM2 (Ώۉ摜)
                feature = New FVIL.FPM2.CFviFPM2Feature(m_image, m_matchmode, m_edgeparam, checkBoxBorderFlg.Checked)
            Else
                'FPM2 (Ώۉ摜)
                feature = New FVIL.FPM2.CFviFPM2Feature(m_image, m_matchmode, m_sobelparam, checkBoxBorderFlg.Checked)
            End If
            m_matching.Target = feature             '(Ώۉ摜)

            'ԑJn
            m_timer.Start()
            '摜s
            m_matching.Execute()
            'ԑI
            msec = m_timer.Stop()
            Result = True
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        Return (Result)
    End Function

    ''' <summary>
    ''' ʕ\
    ''' </summary>
    ''' <remarks>
    ''' ʕ\֐
    ''' </remarks>
    Private Sub fnResultDisplay()
        Dim i As Integer

        '`NA
        m_overlay.Figures.Clear()

        'p^o^̊_
        Dim offset As FVIL.Data.CFviPoint = m_template.Offset
        Dim width As Double = m_template.Width
        Dim height As Double = m_template.Height

        For i = 0 To (m_matching.ResultSize - 1)
            Dim data As FVIL.FPM2.CFviFPM2Data = m_matching(i)

            '}b`Oʂ̎擾
            Dim pos As FVIL.Data.CFviPoint = data.Position  '񓚈ʒu
            Dim angle As FVIL.Data.CFviAngle = data.Angle   ']p
            Dim scale As Double = data.Scale                'XP[()
            Dim score As Integer = data.Score               'XRA()

            '`
            Dim rect As FVIL.Data.CFviRectangle = New FVIL.Data.CFviRectangle()
            rect.St = New FVIL.Data.CFviPoint(pos.X - offset.X, pos.Y - offset.Y)
            rect.Ed = New FVIL.Data.CFviPoint(rect.St.X + width, rect.St.Y + height)
            rect.Center = offset
            rect.Angle = angle

            '`p
            '`
            Dim ol_rect As FVIL.GDI.CFviGdiRectangle = New FVIL.GDI.CFviGdiRectangle(rect)
            ol_rect.Pen.Color = Color.Blue      '(0x00, 0x00, 0xFF)
            ol_rect.FillEnable = True
            ol_rect.FillAlpha = 63
            ol_rect.FillColor = Color.Red       '(0xFF, 0x00, 0x00)

            '񓚈ʒu
            Dim ol_pos As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint(pos)
            ol_pos.Size = New Size(5, 5)
            ol_pos.Pen.Color = Color.Red        '(0xFF, 0x00, 0x00)
            ol_pos.Angle = rect.Angle

            'XRA
            Dim ol_score As FVIL.GDI.CFviGdiString = New FVIL.GDI.CFviGdiString()
            ol_score.Text = scale.ToString()
            ol_score.Position = pos
            ol_score.Align = FVIL.GDI.TextAlign.Right Or FVIL.GDI.TextAlign.Bottom
            ol_score.BkMode = FVIL.GDI.BkMode.Transparent
            ol_score.Color = Color.Lime         '(0x00, 0xFF, 0x00)
            ol_score.Angle = rect.Angle

            'XP[
            Dim ol_scale As FVIL.GDI.CFviGdiString = New FVIL.GDI.CFviGdiString()
            ol_scale.Text = scale.ToString("0")
            ol_scale.Position = pos
            ol_scale.Align = FVIL.GDI.TextAlign.Right Or FVIL.GDI.TextAlign.Top
            ol_scale.BkMode = FVIL.GDI.BkMode.Transparent
            ol_scale.Color = Color.Chartreuse    '(0x7F, 0xFF, 0x00)
            ol_scale.Angle = rect.Angle

            'X
            Dim ol_angle As FVIL.GDI.CFviGdiString = New FVIL.GDI.CFviGdiString()
            ol_angle.Text = rect.Angle.Degree.ToString("0")
            ol_angle.Position = New FVIL.Data.CFviPoint(pos.X, pos.Y + ol_scale.Font.Height)
            ol_angle.Align = FVIL.GDI.TextAlign.Right Or FVIL.GDI.TextAlign.Top
            ol_angle.BkMode = FVIL.GDI.BkMode.Transparent
            ol_angle.Color = Color.Aqua         '(0x00, 0xFF, 0xFF)
            ol_angle.Angle = rect.Angle
            ol_angle.Axis = New FVIL.Data.CFviPoint(0, -ol_scale.Font.Height)

            'ǉ
            m_overlay.Figures.Add(ol_rect)
            m_overlay.Figures.Add(ol_pos)
            m_overlay.Figures.Add(ol_score)
            m_overlay.Figures.Add(ol_scale)
            m_overlay.Figures.Add(ol_angle)

            'Xg\
            If (i = 0) Then
                Dim listitem() As String = {msec.ToString("0.000"), i.ToString(), data.Position.X.ToString("0.00"), data.Position.Y.ToString("0.00"), data.Angle.Degree.ToString("0.00"), data.Scale.ToString("0.00"), data.Score.ToString()}
                listViewResult.Items.Add(New ListViewItem(listitem))
            Else
                Dim listitem() As String = {"", i.ToString(), data.Position.X.ToString("0.00"), data.Position.Y.ToString("0.00"), data.Angle.Degree.ToString("0.00"), data.Scale.ToString("0.00"), data.Score.ToString()}
                listViewResult.Items.Add(New ListViewItem(listitem))
            End If
        Next

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' p^o^{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p^o^ptH[\
    ''' </remarks>
    Private Sub buttonSetPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSetPattern.Click
        '摜\tH[
        Dim formProcDisplay As Form_ProcDISPLAY = New Form_ProcDISPLAY()
        formProcDisplay.Text = "Set Pattern"

        'p^f[^ݒ
        formProcDisplay.Set_image(m_image)
        formProcDisplay.Set_pattern(m_pattern)
        formProcDisplay.Set_OverlayPattern()

        '摜\
        formProcDisplay.ShowDialog(Me)

        'p^\{^L
        buttonDisplayPattern.Enabled = True
        'p^ۑ{^L
        buttonSavePattern.Enabled = True
        '}XNݒ{^L
        buttonDisplayMask.Enabled = True
    End Sub

    ''' <summary>
    ''' p^Ǎ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p^摜̃[h
    ''' </remarks>
    Private Sub buttonLoadPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonLoadPattern.Click
        '͉摜t@C̃[h
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Filter = "Pnt t@C (*.pat)|*.pat"
        OpenFileDialog1.DefaultExt = "*.pat"
        If ((OpenFileDialog1.FileNames.Length <= 0) Or (OpenFileDialog1.ShowDialog(Me) = DialogResult.Cancel)) Then
            Return
        End If

        Try
            m_pattern.Load(OpenFileDialog1.FileName)

            'p^\{^L
            buttonDisplayPattern.Enabled = True
            'p^ۑ{^L
            buttonSavePattern.Enabled = True
            '}XNݒ{^L
            buttonDisplayMask.Enabled = True
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' p^\{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p^\ptH[\B
    ''' </remarks>
    Private Sub buttonDisplayPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonDisplayPattern.Click
        'p^\tH[
        Dim formPtnDisplay As Form_PTNDISPLAY = New Form_PTNDISPLAY()

        'p^̃GbW쐬
        fnMakePatternEdge()
        'p^f[^ݒ
        formPtnDisplay.Set_pattern(m_pattern)
        formPtnDisplay.Set_template(m_template)

        'p^\tH[̕\p^\pɕύX
        formPtnDisplay.Text = "Pattern DISPLAY"
        formPtnDisplay.Mode_Pattern()

        'p^\
        formPtnDisplay.ShowDialog(Me)
    End Sub

    ''' <summary>
    ''' p^ۑ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' p^摜̕ۑB
    ''' </remarks>
    Private Sub buttonSavePattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSavePattern.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.FileName = "Pattern.pat"
        ofdlg.Filter = "Pat t@C (*.pat)|*.pat"
        ofdlg.DefaultExt = "*.pat"
        ofdlg.OverwritePrompt = True
        ofdlg.ShowDialog()
        If (ofdlg.FileNames.Length <= 0) Then
            Return
        End If

        Try
            'p^摜̕ۑ
            m_pattern.Save(ofdlg.FileName)
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' }XNݒ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' }XNݒptH[\B
    ''' </remarks>
    Private Sub buttonDisplayMask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonDisplayMask.Click
        'p^\tH[
        Dim formPtnDisplay As Form_PTNDISPLAY = New Form_PTNDISPLAY()

        'p^̃GbW쐬
        fnMakePatternEdge()
        'p^f[^ݒ
        formPtnDisplay.Set_pattern(m_pattern)
        formPtnDisplay.Set_template(m_template)

        'p^\tH[̕\}XNݒpɕύX
        formPtnDisplay.Text = "Pattern Mask DISPLAY"
        formPtnDisplay.Mode_Mask()

        'p^\
        formPtnDisplay.ShowDialog(Me)
    End Sub

    ''' <summary>
    ''' p^̃GbW쐬
    ''' </summary>
    ''' <remarks>
    ''' p^摜̓ʂ𒊏o֐
    ''' </remarks>
    Private Function fnMakePatternEdge() As Boolean
        Try
            Dim matchmode As FVIL.FPM2.MatchMode
            If (checkBoxMatchMode.Checked = True) Then
                matchmode = FVIL.FPM2.MatchMode.HighSpeed
            Else
                matchmode = FVIL.FPM2.MatchMode.Normal
            End If

            If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                'FPM2 (փGbW)ʒopp[^ݒ
                Dim temp1 As Integer = numericUpDownRegionHeight.Value
                Dim temp2 As Integer = numericUpDownRegionWidth.Value
                If ((temp1 <= temp2) And ((temp1 * temp2) <= 255)) Then
                    m_edgeparam.RegionWidth = numericUpDownRegionWidth.Value
                    m_edgeparam.RegionHeight = numericUpDownRegionHeight.Value
                Else
                    MessageBox.Show("Ǐ̈TCY̏𖞂Ă܂", "Parameter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return (False)
                End If
                m_edgeparam.SigmoidK = Double.Parse(textBoxSigmoidK.Text.ToString())
                m_edgeparam.VarThreshold = Double.Parse(textBoxVarThreshold.Text.ToString())
                m_edgeparam.EdgeThreshold = numericUpDownEdgeThreshold.Value
                m_edgeparam.NmsLength = numericUpDownNmsLength.Value
                'FPM2 (ev[g)
                m_template = New FVIL.FPM2.CFviFPM2Template(m_pattern, matchmode, m_edgeparam)
            Else
                'FPM2 (\[x)ʒopp[^ݒ
                m_sobelparam.EdgeThreshold = numericUpDownEdgeThreshold.Value
                m_sobelparam.NmsLength = numericUpDownNmsLength.Value
                'FPM2 (ev[g)
                m_template = New FVIL.FPM2.CFviFPM2Template(m_pattern, matchmode, m_sobelparam)
            End If
            m_matching.Template = m_template       '(ev[g)
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ʂ̐Ɏs܂BErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return (False)
        End Try
        Return (True)
    End Function

    ''' <summary>
    ''' FPM2GbWo@IR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' փGbWE\[x̑IB
    ''' </remarks>
    Private Sub ComboBoxSelectFilter_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxSelectFilter.SelectedIndexChanged
        If (ComboBoxSelectFilter.SelectedIndex = 0) Then
            'փGbWpp[^\
            numericUpDownRegionHeight.Visible = True
            numericUpDownRegionWidth.Visible = True
            textBoxSigmoidK.Visible = True
            textBoxVarThreshold.Visible = True
            labelRegionWidth.Visible = True
            labelRegionHeight.Visible = True
            labelSigmoidK.Visible = True
            labelVarThreshold.Visible = True
            labelCondition1.Visible = True
            labelCondition2.Visible = True
            labelCondition3.Visible = True
            'փGbWpp[^lݒ
            numericUpDownEdgeThreshold.Maximum = 255
            numericUpDownEdgeThreshold.Value = m_edgeparam.EdgeThreshold
            numericUpDownNmsLength.Value = m_edgeparam.NmsLength
        Else
            'փGbWpp[^\
            numericUpDownRegionHeight.Visible = False
            numericUpDownRegionWidth.Visible = False
            textBoxSigmoidK.Visible = False
            textBoxVarThreshold.Visible = False
            labelRegionWidth.Visible = False
            labelRegionHeight.Visible = False
            labelSigmoidK.Visible = False
            labelVarThreshold.Visible = False
            labelCondition1.Visible = False
            labelCondition2.Visible = False
            labelCondition3.Visible = False
            '\[xGbWpp[^lݒ
            numericUpDownEdgeThreshold.Maximum = 1023
            numericUpDownEdgeThreshold.Value = m_sobelparam.EdgeThreshold
            numericUpDownNmsLength.Value = m_sobelparam.NmsLength
        End If
    End Sub

    ''' <summary>
    ''' }b`O[h`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' FPM _p }b`O[h̐ݒB
    ''' </remarks>
    Private Sub checkBoxMatchMode_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBoxMatchMode.CheckedChanged
        'FPM _p }b`O[hݒ
        If (checkBoxMatchMode.Checked = True) Then
            m_matchmode = FVIL.FPM2.MatchMode.HighSpeed
        Else
            m_matchmode = FVIL.FPM2.MatchMode.Normal
        End If
    End Sub

    ''' <summary>
    ''' 摜GbW\`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜̃GbW̕\ؑւ܂B
    ''' </remarks>
    Private Sub checkBoxEdgeDisplay_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBoxEdgeDisplay.CheckedChanged
        Try
            If (checkBoxEdgeDisplay.Checked = True) Then
                Dim feature As FVIL.FPM2.CFviFPM2Feature
                Dim edges_image As List(Of FVIL.Edge.CFviEdgeData)

                m_overlayEdge.Figures.Clear()

                If (ComboBoxSelectFilter.SelectedIndex = 0) Then
                    Dim temp1, temp2 As Integer

                    'FPM2 (փGbW)ʒopp[^ݒ
                    temp1 = numericUpDownRegionHeight.Value
                    temp2 = numericUpDownRegionWidth.Value
                    If ((temp1 <= temp2) And ((temp1 * temp2) <= 255)) Then
                        m_edgeparam.RegionWidth = numericUpDownRegionWidth.Value
                        m_edgeparam.RegionHeight = numericUpDownRegionHeight.Value
                    Else
                        MessageBox.Show("Ǐ̈TCY̏𖞂Ă܂", "Parameter Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        Return
                    End If
                    m_edgeparam.SigmoidK = Double.Parse(textBoxSigmoidK.Text.ToString())
                    m_edgeparam.VarThreshold = Double.Parse(textBoxVarThreshold.Text.ToString())
                    m_edgeparam.EdgeThreshold = numericUpDownEdgeThreshold.Value
                    m_edgeparam.NmsLength = numericUpDownNmsLength.Value

                    'FPM2 (Ώۉ摜)
                    feature = New FVIL.FPM2.CFviFPM2Feature(m_image, m_matchmode, m_edgeparam, checkBoxBorderFlg.Checked)
                Else
                    'FPM2 (\[x)ʒopp[^ݒ
                    m_sobelparam.EdgeThreshold = numericUpDownEdgeThreshold.Value
                    m_sobelparam.NmsLength = numericUpDownNmsLength.Value

                    'FPM2 (Ώۉ摜)
                    feature = New FVIL.FPM2.CFviFPM2Feature(m_image, m_matchmode, m_sobelparam, checkBoxBorderFlg.Checked)
                End If

                'Ώۉ摜̃GbW_
                edges_image = feature.GetFeatureEdges()

                'GbW̕\
                Dim i As Integer
                For i = 0 To (edges_image.Count - 1)
                    Dim edge As FVIL.Edge.CFviEdgeData = edges_image(i)
                    'GbWʒu  }[N\ (0x)
                    Dim position As FVIL.GDI.CFviGdiPoint = New FVIL.GDI.CFviGdiPoint(edge.Position)
                    position.Size = New System.Drawing.Size(3, 1)
                    position.Style = FVIL.GDI.FigureStyle.Arrow
                    position.Angle = edges_image(i).Angle
                    position.Pen.Color = Color.Lime         '(0x00, 0xFF, 0x00)
                    m_overlayEdge.Figures.Add(position)
                Next
            Else
                m_overlayEdge.Figures.Clear()
            End If
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As FVIL.CFviException
            'G[
            MessageBox.Show(String.Format("ErrorCode={0}", ex.ErrorCode), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            'G[
            MessageBox.Show("ErrorCode={0}" + m_video.ErrorCode, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' ͈͐ݒ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ͈͐ݒptH[\B
    ''' </remarks>
    Private Sub buttonRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonRegion.Click
        '摜\tH[
        Dim formProcDisplay As Form_ProcDISPLAY = New Form_ProcDISPLAY()
        formProcDisplay.Text = "Set Area"

        '摜f[^ݒ
        formProcDisplay.Set_image(m_image)
        formProcDisplay.Set_OverlayProc()

        '摜\
        formProcDisplay.ShowDialog(Me)

        'ĕ`
        CFviImageView1.Refresh()
    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click

        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        CFviImageView1.Display.Magnification = 1.0      '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click

        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        CFviImageView1.FitImageSize()                   '\{𒲐
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value + 0.5
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageView1.Display.OverlayAscope.Enable = True
            CFviImageView1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageView1.Display.OverlayAscope.Enable = False
            CFviImageView1.Display.OverlayAscope.Active = False
        End If
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        If (m_flgVideoOpened = True) Then
            m_video.Close()
            m_flgVideoOpened = False
        End If
    End Sub

    ''' <summary>
    ''' XileLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Xiľ덷͈͂̃G[oB
    ''' </remarks>
    Private Sub textBoxAreaErrorRangeTx_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles textBoxAreaErrorRangeTx.TextChanged
        Try
            m_paramA.ErrorRangeTx = Double.Parse(textBoxAreaErrorRangeTx.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            textBoxAreaErrorRangeTx.Text = "0.5"
        End Try
    End Sub

    ''' <summary>
    ''' YileLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Yiľ덷͈͂̃G[oB
    ''' </remarks>
    Private Sub textBoxAreaErrorRangeTy_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles textBoxAreaErrorRangeTy.TextChanged
        Try
            m_paramA.ErrorRangeTy = Double.Parse(textBoxAreaErrorRangeTy.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            textBoxAreaErrorRangeTy.Text = "0.5"
        End Try
    End Sub

    ''' <summary>
    ''' ]peLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ]p̌덷͈͂̃G[oB
    ''' </remarks>
    Private Sub textBoxAreaErrorRangeTq_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles textBoxAreaErrorRangeTq.TextChanged
        Try
            m_paramA.ErrorRangeTq = Double.Parse(textBoxAreaErrorRangeTq.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            textBoxAreaErrorRangeTq.Text = "0.5"
        End Try
    End Sub

    ''' <summary>
    ''' XP[eLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' XP[̌덷͈͂̃G[oB
    ''' </remarks>
    Private Sub textBoxAreaErrorRangeTs_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles textBoxAreaErrorRangeTs.TextChanged
        Try
            m_paramA.ErrorRangeTs = Double.Parse(textBoxAreaErrorRangeTs.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            textBoxAreaErrorRangeTs.Text = "0.5"
        End Try
    End Sub

    ''' <summary>
    ''' mCYf[^d݌WeLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' wïmCYf[^d݌W̃G[oB
    ''' </remarks>
    Private Sub textBoxAreaNoiseWeight_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles textBoxAreaNoiseWeight.TextChanged
        Try
            m_paramA.NoiseWeight = Double.Parse(textBoxAreaNoiseWeight.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            textBoxAreaNoiseWeight.Text = "0.2"
        End Try
    End Sub

    ''' <summary>
    ''' VOCh֐KeLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' VOCh֐̃p[^k̃G[oB
    ''' </remarks>
    Private Sub textBoxSigmoidK_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles textBoxSigmoidK.TextChanged
        Try
            m_edgeparam.SigmoidK = Double.Parse(textBoxSigmoidK.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            textBoxSigmoidK.Text = "1.0"
        End Try
    End Sub

    ''' <summary>
    ''' U臒leLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' U臒l̃G[oB
    ''' </remarks>
    Private Sub textBoxVarThreshold_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles textBoxVarThreshold.TextChanged
        Try
            m_edgeparam.VarThreshold = Double.Parse(textBoxVarThreshold.Text.ToString())
        Catch ex As Exception
            'G[
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'ȊO̓͂͏lɂB
            textBoxVarThreshold.Text = "25.0"
        End Try
    End Sub

End Class
